var curl = require("curl");

// example: 1WChTA.PPl-SQ:am3EBXSy0NXQd9uc
function matchApiKey(text) {
    const re = /[^\.]{6}\.[^\:]{6}:[^\"\'\s]{16}/;
    const array = `${text || ""}`.match(re) || [null];
    return array[0];
};

function allowOrigin (origin) {
    const text = `${origin}`.trim().toLowerCase();
    const allowed = [ "localhost", "cdpn", "codepen", "fliptopbox", "ably", "codesandbox" ].join("|");
    const re = new RegExp(`(${allowed})`, "i");
    return re.test(text) ? text : null;
};

exports.endpoint = function(request, response) {
    const { origin } = request.headers;
    const allow = allowOrigin(origin);
    const endpoint = "https://www.ably.com/documentation/realtime/presence";
    
    if(!allow) return response.end();

    const headers = {
        'Content-Type': 'application/json',
        'Access-Control-Allow-Origin': allow,
        'Access-Control-Allow-Methods': 'POST, GET, OPTIONS'
    };

    curl.get(endpoint, {}, (e,a,html) => {
        const key = matchApiKey(html);
        
        let payload = { key, origin, ts: new Date().valueOf() };
        payload = JSON.stringify(payload);

        response.writeHead(200, headers);
        response.end(payload);
    });
};



//> fetch("https://demokey-ow7y8lsypzxi.runkit.sh/").then(s => s.json()).then(console.log);

//> {"key":"abcdef.ABCDEF:012345678abc", "origin":"http://domain.com/"};
